void keyPressed() {
  if(selIndex<-1){
     textField.listen();
  } else
  switch(key){
  case 'e': 
    executing = !executing;
    println("Executing is "+(executing?"ON":"OFF")+".");
    break;
  case 'd': 
    repaint = !repaint;
    println("Repaint is "+(repaint?"ON":"OFF")+".");
    break;
  case 'l':
    lightsOn = !lightsOn;
    break;  
  case 'f': 
  //   addFog = !addFog;
  //  println("Fog is "+(addFog?"ON":"OFF")+".");
    break;
  case 'F':
  //myFog.setDist(100.0*(1.1-zoomFactor),3000.0*(1.1-zoomFactor));
     break;
  case 'p': 
      if(selIndex>-1){
        elementInstances[selIndex].pinned = !elementInstances[selIndex].pinned;
        }
    break;
  case 'o': 
      viewPerspective = !viewPerspective;
    break;
  case 'g': 
      if(selIndex>-1){
        elementInstances[selIndex].initializeVelocity();
        }
    break;
  case 'r': 
      autoRotate = !autoRotate;
      println("AutoRotate is "+(autoRotate?"ON":"OFF")+".");
      break;
  case 'q': 
      exit();
      break;
  case '+':
      saveMyPlace();
      break;
  case '-':
      incrementOfPlace++;
      if(incrementOfPlace>maxIncrementOfPlace) incrementOfPlace = 1;
      loadNextToGoPlace();
      break;
  case 'z': 
      zoomFactor=zoomFactor*1.006;
      break;
  case 'c': 
        checkObjectsEdges = !checkObjectsEdges;
        println("Collision is "+(checkObjectsEdges?"ON":"OFF")+".");
      break;
  case 'x': 
      zoomFactor=zoomFactor*0.994;
      break;
  case 'j':
    println("Saving a JPG file...");
    saveFrame("screen-capture-"+frameCount+".jpg");
    break;
  case 't':
    println("Saving a TIF file...");
    saveFrame("screen-capture-"+frameCount+".tif");
    break;
  case 'y': 
      export = true;
      exportType=0; //RHINO COMMAND LINE
      println("Saving a RHINO COMMAND LINE file: .txt ...");
    break;
  case 'k': 
      export = true;
      exportType=1; //DXF
      println("Saving a DXF file: .dxf ...");
    break;
   case 'L': 
      export = true;
      exportType=2; //COLLADA
      println("Saving a COLLADA file: .cda ...");
    break;
   case '.': 
      export = true;
      exportType=3; //STL
      println("Saving a STL file: .cda ...");
    break;
   case ',': 
      export = true;
      exportType=4; //PDF
      println("Saving a PDF file: .pdf ...");
    break;
  case 'h': 
      if(selIndex>-1){
        if(elementInstances[selIndex].hidden){
        elementInstances[selIndex].hidden = false;
        resetConnections();
        updateAllConnections();
        } else {
        elementInstances[selIndex].hidden = true;
        updateAllConnections();
        }
        }
    break;
  case ' ':
     visualInterface[2].inUse = !visualInterface[2].inUse;
     for(int i=0; i<elementInstances.length; i++){
       elementInstances[i].updateSize();
     }
     break;
  case '0': 
    repaint = true; executing = false; showCurves = false; fastMode = false; showLeverage = false;
    checkBorders = false; checkObjectsEdges = false; autoRotate = false; threeD = false;
    zoomExtent[0] = 0.0; zoomExtent[1] = 0.0; zoomExtent[2] = 0.0;
    noLoop();
    setup();
    loop();
    break;
  case '1': 
    showCurves = !showCurves;
    checkObjectsEdges = showCurves;
    break;
  case '2': 
    executing = !executing;
    showLeverage = true;
    showCurves = true;
    break;
  case '3': 
    if(!threeD){
      
    myCol = color(255, 255, 255, 128);
    myStr = color(255, 255, 255);//(24, 136, 180);
    mySel = color(246,255,53,156);
    myPin = color(255,164,2,128);
    threeD = true;
    
    checkObjectsEdges = threeD;
    
    } else {
    
    myCol = color(255, 255, 255);
    myStr = color(255, 255, 255);//(24, 136, 180);
    mySel = color(246,255,53);
    myPin = color(255,164,2);
    threeD = false;
    
    
    }
    break;
  case '4': 
       
    myCol = color(255, 255, 255, 200);
    myStr = color(255, 255, 255);//(24, 136, 180);
    mySel = color(246,255,53, 200);
    myPin = color(255,164,2, 200);
  
  
    drawOrography++;
    if(drawOrography>1)
    drawOrography = 0;
    break;
  case '5': 
    oroFileIndex++;
    if(oroFileIndex >= oroSources.length)
      oroFileIndex=0;
    orographyWidth=0;  orographyDepth=0;
    orography = loadMountainFile();
    break;
  case '6': 
    autoRotate = !autoRotate;
    break;
  case '7': 
    lightsOn = !lightsOn;
    weatherOn = !weatherOn;
    break;
  case '8': 
    executing = false;
    checkObjectsEdges = false;
    incrementOfPlace++;
    if(incrementOfPlace>maxIncrementOfPlace) incrementOfPlace = 1;
    loadNextToGoPlace();
    break;
  case '9': 
    executing = false;
    checkObjectsEdges = false;
    incrementOfPlace--;
    if(incrementOfPlace<1) incrementOfPlace = maxIncrementOfPlace;
    loadNextToGoPlace();
    break;
  case 'n': 
    selIndex++;
    if(selIndex>=elementInstances.length)
     selIndex=0;
    break;
  case 'b': 
    selIndex--;
    if(selIndex<0)
     selIndex=elementInstances.length-1;
    break;
  case 'v': 
    mouseMovementPlane++;
    if(mouseMovementPlane>2)
      mouseMovementPlane = 0;
     break;
  case 'i':
    initializeAllVelocities();
    break;
  case 'm':
    println("Mirroring scene.");
    mirrorScene();
    break;
  case 'w':
    weatherOn = !weatherOn;
    break;
  case 's':
    repaint = true; executing = true; fastMode = false; showLeverage = true; checkBorders = false; checkObjectsEdges = false; autoRotate = false; showCurves=true; threeD = true;
    visualInterface[2].inUse = showLeverage;
    for(int i=0; i<elementInstances.length; i++){
      elementInstances[i].updateSize();
    }
    
    break;
  }
}

