int selIndex = -1;
int pSelIndex = -1;
float mouseMovementXSign = 1;
float mouseMovementYSign = 1;
float mouseMovementZSign = 1;
boolean swapAxis = false;
int mouseMovementPlane = 0;

void mousePressed() {
  //noLoop();
  boolean doneSmthg = false;
  if (mouseButton == LEFT) {
    
   if(showLeverage){
    //GET THE HELPBAR
   if(mouseX>(width-45) && mouseX<(width-15)){
     
     for(int i=0; i<visualInterface.length; i++){
     if(mouseY>(height-65-i*90) && mouseY<(height+10-i*95)){
      selIndex = 0-2-i;
      return;
      }
     }
   }}

    //GET THE OBJECTS
    for (int i = 0; i < diagram.length; i = i+1){
      if(!elementInstances[i].hidden)
      if(elementInstances[i].myScreenPos[0]>mouseX-30 && elementInstances[i].myScreenPos[0]<mouseX+30){
        if(elementInstances[i].myScreenPos[1]>mouseY-20 && elementInstances[i].myScreenPos[1]<mouseY+20){
          selIndex = i;
          doneSmthg = true;
          //break;
        }
      }
      if(!doneSmthg)selIndex = -1;
    }
    redraw(); 
  } else if(mouseButton == CENTER){
  cursor(MOVE);
  }else if(mouseButton == RIGHT){
  cursor(CROSS);
  }
}

void mouseDragged() {
 if (mouseButton == LEFT) {
  if(selIndex<-1){
    

   //Evaluator selected
     visualInterface[0-selIndex-2].myValue += ((pmouseY - mouseY + random(-1.0,1.0))/40.0);
     if(visualInterface[0-selIndex-2].myValue>1.0)
        visualInterface[0-selIndex-2].myValue=1.0;
     else if(visualInterface[0-selIndex-2].myValue<0.0)
        visualInterface[0-selIndex-2].myValue=0.0;
     
     executeUpdateOperations(0-selIndex-2);
   
  } else if(selIndex==-1){
  
    //Nothing selected
  
  }else{
  
   if(mouseMovementPlane==0){
     if(!swapAxis){
      elementInstances[selIndex].myPos[0] += (mouseX - pmouseX)/(zoomFactor)*mouseMovementYSign*mouseMovementZSign;
      elementInstances[selIndex].myPos[1] += (mouseY - pmouseY)/(zoomFactor)*mouseMovementXSign*mouseMovementZSign;
      }else{
      elementInstances[selIndex].myPos[0] += (mouseY - pmouseY)/(zoomFactor)*mouseMovementXSign*mouseMovementZSign;
      elementInstances[selIndex].myPos[1] -= (mouseX - pmouseX)/(zoomFactor)*mouseMovementYSign*mouseMovementZSign;
      }
      elementInstances[selIndex].myVel[0] = 0;
      elementInstances[selIndex].myVel[1] = 0;
      elementInstances[selIndex].myVel[2] = 0;
   

    }else if(mouseMovementPlane==1){
     if(!swapAxis){
      elementInstances[selIndex].myPos[2] += (mouseX - pmouseX)/(zoomFactor)*mouseMovementXSign*mouseMovementYSign;
      elementInstances[selIndex].myPos[0] -= (mouseY - pmouseY)/(zoomFactor)*mouseMovementZSign*mouseMovementYSign;
     }else{
      elementInstances[selIndex].myPos[2] += (mouseY - pmouseY)/(zoomFactor)*mouseMovementZSign*mouseMovementYSign;
      elementInstances[selIndex].myPos[0] -= (mouseX - pmouseX)/(zoomFactor)*mouseMovementXSign*mouseMovementYSign;
     }
      elementInstances[selIndex].myVel[0] = 0;
      elementInstances[selIndex].myVel[1] = 0;
      elementInstances[selIndex].myVel[2] = 0;
      

    }else if(mouseMovementPlane==2){
     if(!swapAxis){
      elementInstances[selIndex].myPos[2] += (mouseX - pmouseX)/(zoomFactor)*mouseMovementYSign*mouseMovementXSign;
      elementInstances[selIndex].myPos[1] += (mouseY - pmouseY)/(zoomFactor)*mouseMovementZSign*mouseMovementXSign;
      }else{
      elementInstances[selIndex].myPos[2] += (mouseX - pmouseX)/(zoomFactor)*mouseMovementYSign*mouseMovementXSign;
      elementInstances[selIndex].myPos[1] += (mouseY - pmouseY)/(zoomFactor)*mouseMovementZSign*mouseMovementXSign;
      }
      elementInstances[selIndex].myVel[0] = 0;
      elementInstances[selIndex].myVel[1] = 0;
      elementInstances[selIndex].myVel[2] = 0;


    }
  
  }
  
  //redraw();
} else if(mouseButton == CENTER){
  
    if(keyPressed){
      if(key == CODED && keyCode == CONTROL){
      zoomExtent[2] += (mouseX - pmouseX);
      zoomExtent[2] += (mouseY - pmouseY);
      }} else {
   zoomExtent[0] += (mouseX - pmouseX);
   zoomExtent[1] += (mouseY - pmouseY);
   }
  
} else if(mouseButton == RIGHT){
  
  if(keyPressed && key == CODED && keyCode == CONTROL){
       zRotation += (pmouseY - mouseY)/150.0;
       zRotation += (pmouseX - mouseX)/150.0;
      } else {
  xRotation += (pmouseY - mouseY)/600.0;
  yRotation += (mouseX - pmouseX)/300.0;
  }
   
   //FINDS THE CLOSEST ORTHOGONAL PLANE TO WORK ON
   //AVOID THIS BEHAVIOUR WITH SHIFT
    if(!(keyPressed && key == CODED && keyCode == SHIFT) && threeD){
     
   boolean axisX = abs(cos(xRotation))>0.5;
   boolean axisY = abs(cos(yRotation))>0.5;
   boolean axisZ = abs(sin(zRotation))>0.5;
   
   mouseMovementXSign = sign(cos(xRotation-PI/4.0));
   mouseMovementYSign = sign(cos(yRotation-PI/4.0));
   mouseMovementZSign = sign(cos(zRotation));
   
   
   if(axisX^axisY^axisZ){
     axisX=!axisX;
     axisY=!axisY;
     axisZ=!axisZ;
     swapAxis = true;
     //print("OPPOSITE");
   } else
     swapAxis = false;
     
      //println(mouseMovementXSign+" --- "+mouseMovementYSign+" --- "+mouseMovementZSign);
      //println(axisX+" "+axisY+" "+axisZ);
   
   if(!axisZ){
    mouseMovementPlane=0;
    addInfo = " (XY)";
   }else if(!axisY){
    mouseMovementPlane=1;
    addInfo = " (XZ)";
   }else if(!axisX){
    mouseMovementPlane=2;
    addInfo = " (YZ)";
   }else{
      println("Unexpected position. Error.");
   }
   
   }
   
  
}


}

void mouseReleased(){
if(mouseButton == LEFT){
  if(!(selIndex<=-1)){
  
  }} else if(mouseButton == CENTER){
  cursor(ARROW);
  } else if(mouseButton == RIGHT){
  cursor(ARROW);
  }
}


class MouseWheelInput implements MouseWheelListener{
  void mouseWheelMoved(MouseWheelEvent evt) {
    
      float notches = float(evt.getWheelRotation());
      zoomFactor = zoomFactor*(notches/25.0+1.0);
      if(threeD){
      zoomExtent[0] = zoomExtent[0]*(notches/25.0+1.0);
      zoomExtent[1] = zoomExtent[1]*(notches/25.0+1.0);
      }
   }
}


private void executeUpdateOperations(int n){
  switch(n){
  case 0:
     noLoop();
     resetConnections();
     updateAllVisibility();
     updateAllConnections();
     loop();
    break;
  case 2:
    visualInterface[2].inUse = true;
    for(int i=0; i<elementInstances.length; i++){
    elementInstances[i].updateSize();
    }
    break;
 }
}

//(c) Giulio Piacentino 2008. Some rights reserved.
